import requests
import json
from datetime import datetime
import csv

login="email@mail.ru"
password="пароль$"

def get_companies(cookies):

 # URL of the API endpoint
 url = "https://app.skif.pro/api_v1/auth_admin_query"
 
 # Headers for the request
 headers = {
    "Host": "admin.skif.pro",
    "User-Agent": "Mozilla/5.0 (X11; Linux x86_64; rv:133.0) Gecko/20100101 Firefox/133.0",
    "Accept": "application/json, text/plain, */*",
    "Accept-Language": "ru,en-US;q=0.7,en;q=0.3",
    "Accept-Encoding": "gzip, deflate, br, zstd",
    "Content-Type": "application/json",
    "X-Requested-With": "XMLHttpRequest",
    "Origin": "https://admin.skif.pro",
    "Connection": "keep-alive",
    "Referer": "https://admin.skif.pro/company"
 }
 
 # JSON body for the POST request
 payload = {
     "model": "companies",
     "fields": [
         "id",
         "name",
         "timezone_key",
         "users_count",
         "creator",
         "amount",
         "tariff.units",
         "dealer_id",
         "billing",
         "units"
     ],
     "from": 0,
     "count": 100,
     "value": "",
     "field": "",
     "conditions": [
         {"field": "billing.company_status", "value": "ACTIVE"}
     ],
     "companies": [],
     "dealer": {
         "id": "Укажите ID дилера"
     }
 }
 
 # Make the HTTP GET request
 response = requests.post(url, headers=headers, cookies=cookies, json=payload)
 
 # Check if the request was successful
 if response.status_code == 200:
     try:
        data = response.json()
        # Current date for comparison
        current_date = datetime.now()
        
        # Open a CSV file to write the results
        with open("Компании.csv", "w", newline="", encoding="utf-8") as csvfile:
            writer = csv.writer(csvfile)
            writer.writerow(["Название", "Статус", "Дата оплаты", "До", "Объекты"])  # Write the header
        
            # Process the JSON data
            for item in data.get("list", []):
                billing = item.get("billing", {})
                valid_from_str = billing.get("valid_from")
                valid_to_str = billing.get("valid_to")
                company_status = billing.get("company_status")
                name = item.get("name")
                units = item.get("units")
                # Write the data to the CSV file
                writer.writerow([name, company_status, valid_from_str, valid_to_str, units])
        
        print("Файл сформировна, смотрите файл: Компании.csv")
 
     except ValueError:
         print("Ошибка: Response is not in JSON format")
 else:
     print(f"Ошибочный ответ, код {response.status_code}")
     print("Ответ:", response.text)

# Login URL
login_url = "https://admin.skif.pro/api_v1/login"

# JSON body for login
login_payload = {
    "userProviderId": login,
    "provider_key": "EMAIL",
    "password": password 
}

# Headers for the login request
headers = {
    "User-Agent": "MyApp/1.0",
    "Content-Type": "application/json"
}

# Make the login POST request
response = requests.post(login_url, json=login_payload, headers=headers)

# Check if the login was successful
if response.status_code == 200:
    # Extract cookies from the response
    cookies = response.cookies.get_dict()
    get_companies(cookies)
    print("Успешная авторизация!")
else:
    print(f"Ошибка авторизации код {response.status_code}")
    print("Ответ:", response.text)
